// =====================================================================================
//
//       Filename:  tsdb_lib_local_sample.c
//
//    Description:  
//                     code edit with vim and and tw=2, default code is under utf-8.
//
//        Version:  $Id$
//        Created:  2023/3/17 20:13:39
//       Revision:  none
//       Compiler:  modern c/c++ compiler, at least c++17 is requiment.
//                        ( test under gcc 10.2.1 and vs2019 ).
//
//         Author:  lk (yy), lk@shucantech.com
//				Company:  sct
//   Organization:  sct-p
//
//				License:  sct-cl v0
//
// =====================================================================================


#include <stdlib.h>
#include <stdio.h>
#include "tsdb_lib.h"

void print_bymyself(void* d) {

  int r = rows_of(d);
  int c = cols_of(d);
  printf("\n");
  for (size_t i = 0; i < c; ++i) {
    int s = 0;
    const char* n = col_name(&s, d, i);
    printf("%.*s ", s, n);
  }
  printf("\n");
  for (size_t i = 0; i < r; ++i) {
    for (size_t j = 0; j < c; ++j) {
      void* v = at(i, j, d);
      int g = val_sign(v); int s = val_size(v); int t = val_type(v);
      if (t == VAL_TYPE_I) {
        if (s == VAL_SIZE_1) {          printf(" %d", g == VAL_SIGN ? as_int8(v) : as_uint8(v));
        } else if (s == VAL_SIZE_2) {   printf(" %d", g == VAL_SIGN ? as_int16(v) : as_uint16(v));
        } else if (s == VAL_SIZE_4) {   printf(" %d", g == VAL_SIGN ? as_int32(v) : as_uint32(v));
        } else {                        printf(" %d", g == VAL_SIGN ? as_int64(v) : as_uint64(v));    }
      } else if (t == VAL_TYPE_F) {     printf(" %f", s == VAL_SIZE_4 ? as_float(v) : as_double(v));
      } else if (t == VAL_TYPE_D) {     int y, m, d;  as_date(&y, &m, &d, v);
      } else if (t == VAL_TYPE_S){
        char* p = NULL; int c = 0;
        as_str(&p, &c, v);
        if( p != NULL ){ printf(" %.*s", c, p); free(p); }
      } else {}
    }
    printf("\n");
  }
}

int main(int argc, char** argv) {
  void* d = exec("view tab id value max 10");
  if( d == NULL ){ printf("execute tsdb command failed\n"); return 0; }
  print(d);
  print_bymyself(d);
  del_datas(d);
  return 0;
}